############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################

from xml.dom.ext.reader import PyExpat
from xml.dom.ext import c14n

class ElementProxy:
    def __init__(self):
        self._doc = None
        self._reader = PyExpat.Reader()
        
    def fromString(self, xmlInstance):
        self._doc = self._reader.fromString(xmlInstance)

    def canonicalize(self):
        """return c14n string
        """
        textMsg = c14n.Canonicalize(self._doc)
        self.fromString(textMsg)
